#ifndef MASC_FACTORY_H
#define MASC_FACTORY_H

/**----------------------------------------------------------------------------
  @file MascFactory.h

-----------------------------------------------------------------------------*/

/*=============================================================================
    Copyright (c) 2014 Qualcomm Technologies, Inc.  All Rights Reserved.
    Qualcomm Technologies Proprietary and Confidential.
============================================================================*/

/*------------------------------------------------------------------------------
 * Include Files
 * ---------------------------------------------------------------------------*/
 #include "CneMascInterface.h"
class CneAtp;
class ICneMasc;
class ICneMascReportMgr;
class AtpQmiClient;

class MascFactory:public CneMascInterface
{
public:

  /*----------------------------------------------------------------------------
   * Public Types
   * -------------------------------------------------------------------------*/

  /*----------------------------------------------------------------------------
   * Public Method Specifications
   * -------------------------------------------------------------------------*/

   /*----------------------------------------------------------------------------
   * FUNCTION      constructor
   *
   * DESCRIPTION   Create instance of WqeFactory class
   *
   * DEPENDENCIES  Logging
   *
   * RETURN VALUE  None
   *
   * SIDE EFFECTS  None
   *--------------------------------------------------------------------------*/
   MascFactory();

   /*----------------------------------------------------------------------------
   * FUNCTION      destructor
   *
   * DESCRIPTION   deletes necessary class variables
   *
   * DEPENDENCIES  Logging
   *
   * RETURN VALUE  None
   *
   * SIDE EFFECTS  None
   *--------------------------------------------------------------------------*/
   virtual ~MascFactory();

  /*----------------------------------------------------------------------------
   * FUNCTION      createFactory
   *
   * DESCRIPTION   Method to initialize required WQE classes.
   *
   * DEPENDENCIES  Logging
   *
   * RETURN VALUE  None
   *
   * SIDE EFFECTS  None
   *--------------------------------------------------------------------------*/
   virtual void createMasc(CneCom &com, CneTimer &timer);

   /*----------------------------------------------------------------------------
   * FUNCTION      getInstance
   *
   * DESCRIPTION   Method to initialize required WQE classes.
   *
   * DEPENDENCIES  Logging
   *
   * RETURN VALUE  None
   *
   * SIDE EFFECTS  None
   *--------------------------------------------------------------------------*/
   static MascFactory* getInstance();

   /*----------------------------------------------------------------------------
   * FUNCTION      getCneMasc
   *
   * DESCRIPTION   Method to initialize required WQE classes.
   *
   * DEPENDENCIES  Logging
   *
   * RETURN VALUE  None
   *
   * SIDE EFFECTS  None
   *--------------------------------------------------------------------------*/
   virtual ICneMasc* getCneMasc();

   /*----------------------------------------------------------------------------
    * FUNCTION      getCneAtpReportMgr
    *
    * DESCRIPTION   Get instance of CneMasc.
    *
    * DEPENDENCIES  Logging
    *
    * RETURN VALUE  None
    *
    * SIDE EFFECTS  None

    *--------------------------------------------------------------------------*/
   virtual ICneMascReportMgr* getCneMascReportMgr();


  /*----------------------------------------------------------------------------
   * Public Attributes
   * -------------------------------------------------------------------------*/
   ICneMasc *pCneMasc;

   AtpQmiClient *atpQmiClient;

   static MascFactory *instPtr;

   bool isFactoryInitialized;
};

#endif /* _MascFactory_h_ */
