#!/system/bin/sh

set -ex

mount -o remount,rw /system

# If this is an OTA upgrade from 4.2.10 to 4.3.00, move files to correct locations
if [ ! -f /system/vendor/bin/startRIDL.sh ]; then
   mkdir /system/vendor/lib/ || true
   mkdir /system/vendor/bin/ || true
   mkdir /system/vendor/RIDL/ || true
   rm -f /system/vendor/lib/libtar.so
   rm -f /system/vendor/lib/libsregex.so
   cp /data/SelfHost/libtar.so /system/vendor/lib/
   cp /data/SelfHost/libsregex.so /system/vendor/lib/
   cp /data/SelfHost/startRIDL.sh /system/vendor/bin/
   cp /data/SelfHost/installOTA.sh /system/vendor/bin/
   cp /data/SelfHost/RIDLClient.exe /system/vendor/bin/
   cp /data/SelfHost/FixPermissions.exe /system/vendor/bin/
   cp /data/SelfHost/RIDL.new.db /system/vendor/RIDL/RIDL.db
   cp /data/SelfHost/ReadMe.txt /system/vendor/RIDL/
   cp /data/SelfHost/RIDLClient.apk /system/app/
fi

# Double check permissions
chmod 777 /system/vendor/bin/RIDLClient.exe
chmod 777 /system/vendor/bin/FixPermissions.exe
chmod 777 /system/vendor/bin/startRIDL.sh

# Run FixPermissions
/system/vendor/bin/FixPermissions.exe

# FixPermission might set back to ReadOnly
mount -o remount,rw /system

# Add libtar library
chown root:root /system/vendor/lib/libtar.so
chmod 644 /system/vendor/lib/libtar.so

# Add libsregex library
chown root:root /system/vendor/lib/libsregex.so
chmod 644 /system/vendor/lib/libsregex.so

# Uninstall previous versions
pm uninstall org.kde.necessitas.ministro || true
pm uninstall org.kde.necessitas.RIDL || true
pm uninstall com.qualcomm.android.riddle || true
pm uninstall com.qualcomm.RIDL || true
rm -rf /data/local/qt
rm -f /system/app/RIDLC2SService.apk
rm -rf /system/app/RIDLClient/
rm -f /data/SelfHost/DeviceID.txt
rm -f /data/SelfHost/RIDLClient.apk
rm -f /data/SelfHost/RIDLClient.exe
rm -f /data/SelfHost/installOTA.sh
rm -f /data/SelfHost/libtar.so
rm -f /data/SelfHost/libsregex.so

# Merge FileUpload and tokens tables, if they exist
if [ -f /data/SelfHost/RIDL.db ]; then
   if sqlite3 /data/SelfHost/RIDL.db "select username,retrycount from fileupload" > /dev/null; then
      sqlite3 /data/SelfHost/RIDL.new.db "attach '/data/SelfHost/RIDL.db' as old; insert into Fileupload select * from old.FileUpload;" || true
   else
      sqlite3 /data/SelfHost/RIDL.new.db "attach '/data/SelfHost/RIDL.db' as old; insert into Fileupload select *,'Unknown',0 from old.FileUpload;" || true
   fi

   sqlite3 /data/SelfHost/RIDL.new.db "attach '/data/SelfHost/RIDL.db' as old; insert into token select * from old.token;" || true
   sqlite3 /data/SelfHost/RIDL.new.db "attach '/data/SelfHost/RIDL.db' as old; update transState set state = (select * from old.transState);" || true
fi

mv /data/SelfHost/RIDL.new.db /data/SelfHost/RIDL.db

# Restore RIDL mode
if [ -f /data/SelfHost/RIDL.txt ]; then
   sqlite3 /data/SelfHost/RIDL.db "update transState set state = 4;" || true
   rm -f /data/SelfHost/RIDL.txt
fi

# There should never be ActiveData or ActiveRules on install (force rule sync)
sqlite3 /data/SelfHost/RIDL.db "delete from ActiveData;" || true
sqlite3 /data/SelfHost/RIDL.db "delete from ActiveRules;" || true

sync

# Reboot
reboot
