#!/system/bin/sh

# Check if already running
if ps | grep RIDLClient.exe | grep -v grep
then
   echo Already running
   exit
fi

# Mount debugfs to /d for use by MM graphic rules
mount -t debugfs none /d

# Update permissions
su -c chmod 777 /data/SelfHost
su -c chmod 666 /data/SelfHost/RIDL.db
su -c chmod 666 /data/SelfHost/GoldenLogmask.dmc
su -c chcon u:object_r:media_rw_data_file:s0 /data/SelfHost
su -c chcon u:object_r:media_rw_data_file:s0 /data/SelfHost/RIDL.db
su -c chcon u:object_r:media_rw_data_file:s0 /data/SelfHost/GoldenLogmask.dmc

# Restore DB, if deleted
if [ ! -f /data/SelfHost/RIDL.db ]; then
   su -c mkdir /data/SelfHost/ || true
   su -c cp /system/vendor/RIDL/RIDL.db /data/SelfHost/
   su -c cp /system/vendor/RIDL/ReadMe.txt /data/SelfHost/
fi

# Start RIDL service
while true; do
   su -c /system/vendor/bin/RIDLClient.exe
   # RIDL app was running already (EALREADY = 114)
   ERR=$?
   if [ $ERR -eq 114 ]; then
      echo Already running
      exit
   fi
   if [ $ERR -eq 65 ]; then
      echo Mode OFF
      exit
   fi

   su -c logcat -v time -d > /data/SelfHost/RIDLCrash.txt
done

